Index: stable/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- stable/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 15082)
+++ stable/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 15261)
@@ -309,5 +309,5 @@
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <None Include="web.config" />
+    <None Include="Web.config" />
   </ItemGroup>
   <ItemGroup>
Index: stable/HeuristicLab.Services.OKB/3.3/Web.config
===================================================================
--- stable/HeuristicLab.Services.OKB/3.3/Web.config	(revision 15261)
+++ stable/HeuristicLab.Services.OKB/3.3/Web.config	(revision 15261)
@@ -0,0 +1,105 @@
+<?xml version="1.0" encoding="utf-8"?>
+<configuration>
+  <connectionStrings>
+    <add name="HeuristicLab.Authentication" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication"/>
+    <add name="HeuristicLab.Services.OKB.DataAccess.Properties.Settings.OKBConnectionString" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB"/>
+  </connectionStrings>
+
+  <system.web>
+    <authentication mode="Forms" />
+    <compilation debug="true" targetFramework="4.5" />
+    <customErrors mode="Off" />
+    <membership defaultProvider="AspNetSqlMembershipProvider">
+      <providers>
+        <clear />
+        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication"
+             requiresQuestionAndAnswer="false" requiresUniqueEmail="false" applicationName="HeuristicLab.Authentication" minRequiredPasswordLength="8"
+             minRequiredNonalphanumericCharacters="0" maxInvalidPasswordAttempts="5" />
+      </providers>
+    </membership>
+    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
+      <providers>
+        <clear />
+        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" />
+      </providers>
+    </roleManager>
+  </system.web>
+
+  <system.serviceModel>
+    <serviceHostingEnvironment multipleSiteBindingsEnabled="true"/>
+    <services>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.Administration.AdministrationService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.OKB.Administration.IAdministrationService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/OKB-3.3/AdministrationService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.Query.QueryService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          name="WSHttpBinding_IQueryService" contract="HeuristicLab.Services.OKB.Query.IQueryService" />
+        <endpoint address="net.tcp://localhost:8001/OKB-3.3/QueryService.svc"
+          binding="netTcpBinding" bindingConfiguration="DefaultNetBinding"
+          name="NetBinding_IQueryService" contract="HeuristicLab.Services.OKB.Query.IQueryService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/OKB-3.3/QueryService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.RunCreation.RunCreationService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.OKB.RunCreation.IRunCreationService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/OKB-3.3/RunCreationService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+    </services>
+    <bindings>
+      <netTcpBinding>
+        <binding name="DefaultNetBinding" receiveTimeout="00:20:00"
+          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxBufferSize="2147483647"
+          maxReceivedMessageSize="2147483647" portSharingEnabled="true">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security mode="TransportWithMessageCredential">
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </netTcpBinding>
+      <wsHttpBinding>
+        <binding name="DefaultWsHttpBinding" maxBufferPoolSize="2147483647"
+          maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security>
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+    <behaviors>
+      <serviceBehaviors>
+        <behavior name="DefaultServiceBehavior">
+          <serviceMetadata httpGetEnabled="true" />
+          <serviceDebug includeExceptionDetailInFaults="true" />
+          <serviceAuthorization principalPermissionMode="UseAspNetRoles"
+            roleProviderName="AspNetSqlRoleProvider" />
+          <serviceCredentials>
+            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName" />
+            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
+              membershipProviderName="AspNetSqlMembershipProvider" />
+          </serviceCredentials>
+        </behavior>
+      </serviceBehaviors>
+    </behaviors>
+  </system.serviceModel>
+
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5"/>
+  </startup>
+</configuration>
Index: stable/HeuristicLab.Services.OKB/3.3/app.config
===================================================================
--- stable/HeuristicLab.Services.OKB/3.3/app.config	(revision 15082)
+++ stable/HeuristicLab.Services.OKB/3.3/app.config	(revision 15261)
@@ -1,21 +1,25 @@
-<?xml version="1.0"?>
+<?xml version="1.0" encoding="utf-8"?>
 <configuration>
   <connectionStrings>
-    <add name="HeuristicLab.Authentication" connectionString="data source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication"/>
+    <add name="HeuristicLab.Authentication" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication"/>
     <add name="HeuristicLab.Services.OKB.DataAccess.Properties.Settings.OKBConnectionString" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB"/>
   </connectionStrings>
 
   <system.web>
-    <compilation debug="true"/>
-    <membership>
+    <authentication mode="Forms" />
+    <compilation debug="true" targetFramework="4.5" />
+    <customErrors mode="Off" />
+    <membership defaultProvider="AspNetSqlMembershipProvider">
       <providers>
-        <clear/>
-        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication" enablePasswordRetrieval="false" enablePasswordReset="true" requiresQuestionAndAnswer="false" requiresUniqueEmail="false" maxInvalidPasswordAttempts="5" minRequiredPasswordLength="6" minRequiredNonalphanumericCharacters="0" passwordAttemptWindow="10" applicationName="HeuristicLab.Authentication"/>
+        <clear />
+        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication"
+             requiresQuestionAndAnswer="false" requiresUniqueEmail="false" applicationName="HeuristicLab.Authentication" minRequiredPasswordLength="8"
+             minRequiredNonalphanumericCharacters="0" maxInvalidPasswordAttempts="5" />
       </providers>
     </membership>
-    <roleManager enabled="true">
+    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
       <providers>
-        <clear/>
-        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication"/>
+        <clear />
+        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" />
       </providers>
     </roleManager>
@@ -23,63 +27,77 @@
 
   <system.serviceModel>
+    <serviceHostingEnvironment multipleSiteBindingsEnabled="true"/>
+    <services>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.Administration.AdministrationService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.OKB.Administration.IAdministrationService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/OKB-3.3/AdministrationService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.Query.QueryService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          name="WSHttpBinding_IQueryService" contract="HeuristicLab.Services.OKB.Query.IQueryService" />
+        <endpoint address="net.tcp://localhost:8001/OKB-3.3/QueryService.svc"
+          binding="netTcpBinding" bindingConfiguration="NetTcpBinding_IQueryService"
+          name="NetBinding_IQueryService" contract="HeuristicLab.Services.OKB.Query.IQueryService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/OKB-3.3/QueryService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.RunCreation.RunCreationService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.OKB.RunCreation.IRunCreationService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/OKB-3.3/RunCreationService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+    </services>
     <bindings>
-      <mexHttpBinding>
-        <binding name="DefaultMexHttpBinding"/>
-      </mexHttpBinding>
+      <netTcpBinding>
+        <binding name="NetTcpBinding_IQueryService" receiveTimeout="00:20:00"
+          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxBufferSize="2147483647"
+          maxReceivedMessageSize="2147483647" portSharingEnabled="true">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security mode="TransportWithMessageCredential">
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </netTcpBinding>
       <wsHttpBinding>
-        <binding name="DefaultWsHttpBinding" maxReceivedMessageSize="200000000">
-          <readerQuotas maxArrayLength="200000000" maxBytesPerRead="200000000"/>
-          <security mode="Message">
-            <message clientCredentialType="UserName"/>
+        <binding name="DefaultWsHttpBinding" maxBufferPoolSize="2147483647"
+          maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security>
+            <message clientCredentialType="UserName" />
           </security>
         </binding>
       </wsHttpBinding>
     </bindings>
-
     <behaviors>
       <serviceBehaviors>
         <behavior name="DefaultServiceBehavior">
-          <serviceMetadata httpGetEnabled="true"/>
-          <serviceDebug includeExceptionDetailInFaults="true"/>
-          <serviceAuthorization principalPermissionMode="UseAspNetRoles" roleProviderName="AspNetSqlRoleProvider"/>
+          <serviceMetadata httpGetEnabled="true" />
+          <serviceDebug includeExceptionDetailInFaults="true" />
+          <serviceAuthorization principalPermissionMode="UseAspNetRoles"
+            roleProviderName="AspNetSqlRoleProvider" />
           <serviceCredentials>
-            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName"/>
-            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider" membershipProviderName="AspNetSqlMembershipProvider"/>
+            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName" />
+            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
+              membershipProviderName="AspNetSqlMembershipProvider" />
           </serviceCredentials>
-          <dataContractSerializer maxItemsInObjectGraph="6553600"/>
         </behavior>
       </serviceBehaviors>
     </behaviors>
-
-    <services>     
-      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.Administration.AdministrationService">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange"/>
-        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.OKB.Administration.IAdministrationService"/>
-        <host>
-          <baseAddresses>
-            <add baseAddress="http://localhost:8732/Design_Time_Addresses/OKB-3.3/AdministrationService"/>
-          </baseAddresses>
-        </host>
-      </service>
-      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.RunCreation.RunCreationService">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange"/>
-        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.OKB.RunCreation.IRunCreationService"/>
-        <host>
-          <baseAddresses>
-            <add baseAddress="http://localhost:8732/Design_Time_Addresses/OKB-3.3/RunCreationService"/>
-          </baseAddresses>
-        </host>
-      </service>
-      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.OKB.Query.QueryService">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange"/>
-        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.OKB.Query.IQueryService"/>
-        <host>
-          <baseAddresses>
-            <add baseAddress="http://localhost:8732/Design_Time_Addresses/OKB-3.3/QueryService"/>
-          </baseAddresses>
-        </host>
-      </service>
-    </services>
   </system.serviceModel>
+  
   <startup>
     <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5"/>
Index: stable/HeuristicLab.Services.OKB/3.3/web.config
===================================================================
--- stable/HeuristicLab.Services.OKB/3.3/web.config	(revision 15082)
+++ 	(revision )
@@ -1,91 +1,0 @@
-<?xml version="1.0"?>
-<configuration>
-  <connectionStrings>
-    <clear />
-    <add name="HeuristicLab.Authentication"
-           connectionString="data source=.;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication" />
-    <add name="HeuristicLab.Services.OKB.DataAccess.Properties.Settings.OKBConnectionString"
-         connectionString="Data Source=.;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB" />
-  </connectionStrings>
-
-  <system.web>
-    <authentication mode="Forms" />
-    <compilation debug="true" targetFramework="4.0" />
-    <customErrors mode="Off"/>
-    <membership>
-      <providers>
-        <clear />
-        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication"
-             enablePasswordRetrieval="false" enablePasswordReset="true" requiresQuestionAndAnswer="false" requiresUniqueEmail="false"
-             maxInvalidPasswordAttempts="5" minRequiredPasswordLength="6" minRequiredNonalphanumericCharacters="0" passwordAttemptWindow="10"
-             applicationName="HeuristicLab.Authentication" />
-      </providers>
-    </membership>
-    <roleManager enabled="true">
-      <providers>
-        <clear />
-        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication"
-             applicationName="HeuristicLab.Authentication" />
-      </providers>
-    </roleManager>
-  </system.web>
-
-  <system.serviceModel>
-    <bindings>
-      <mexHttpBinding>
-        <binding name="DefaultMexHttpBinding" />
-      </mexHttpBinding>
-      <wsHttpBinding>
-        <binding name="DefaultWsHttpBinding" maxReceivedMessageSize="200000000">
-          <readerQuotas maxArrayLength="200000000" maxBytesPerRead="200000000" />
-          <security mode="Message">
-            <message clientCredentialType="UserName" />
-          </security>
-        </binding>
-      </wsHttpBinding>
-    </bindings>
-
-    <behaviors>
-      <serviceBehaviors>
-        <behavior name="DefaultServiceBehavior">
-          <serviceMetadata httpGetEnabled="true" />
-          <serviceDebug includeExceptionDetailInFaults="true" />
-          <serviceAuthorization principalPermissionMode="UseAspNetRoles" roleProviderName="AspNetSqlRoleProvider" />
-          <serviceCredentials>
-            <serviceCertificate findValue="services.heuristiclab.com" x509FindType="FindBySubjectName" />
-            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider" membershipProviderName="AspNetSqlMembershipProvider" />
-          </serviceCredentials>
-        </behavior>
-      </serviceBehaviors>
-    </behaviors>
-
-    <services> 
-
-      <service name="HeuristicLab.Services.OKB.Administration.AdministrationService" behaviorConfiguration="DefaultServiceBehavior">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange" listenUriMode="Explicit" />
-        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.OKB.Administration.IAdministrationService" listenUriMode="Explicit" />
-      </service>
-
-      <service name="HeuristicLab.Services.OKB.RunCreation.RunCreationService" behaviorConfiguration="DefaultServiceBehavior">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange" listenUriMode="Explicit" />
-        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.OKB.RunCreation.IRunCreationService" listenUriMode="Explicit" />
-      </service>
-
-      <service name="HeuristicLab.Services.OKB.Query.QueryService" behaviorConfiguration="DefaultServiceBehavior">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange" listenUriMode="Explicit" />
-        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.OKB.Query.IQueryService" listenUriMode="Explicit" />
-      </service>
-
-    </services>
-
-    <serviceHostingEnvironment multipleSiteBindingsEnabled="true" />
-  </system.serviceModel>
-
-  <system.webServer>
-    <modules runAllManagedModulesForAllRequests="true" />
-  </system.webServer>
-
-  <startup>
-    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0" />
-  </startup>
-</configuration>