Index: stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs	(revision 14186)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs	(revision 15262)
@@ -73,5 +73,5 @@
 
     #region Child Control Events
-    private void restartButton_Click(object sender, EventArgs e) {
+    private void startButton_Click(object sender, EventArgs e) {
       var task = System.Threading.Tasks.Task.Factory.StartNew(ResumeTaskAsync);
       task.ContinueWith((t) => {
@@ -119,5 +119,5 @@
       base.SetEnabledStateOfControls();
 
-      this.restartButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && (Content.Task.State == TaskState.Paused || Content.Task.State == TaskState.Failed || Content.Task.State == TaskState.Aborted);
+      this.startButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && (Content.Task.State == TaskState.Paused);
       this.pauseButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && Content.Task.State == TaskState.Calculating;
       this.stopButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && (Content.Task.State == TaskState.Calculating || Content.Task.State == TaskState.Waiting || Content.Task.State == TaskState.Paused);
Index: stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.designer.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.designer.cs	(revision 14186)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.designer.cs	(revision 15262)
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.restartButton = new System.Windows.Forms.Button();
+      this.startButton = new System.Windows.Forms.Button();
       this.pauseButton = new System.Windows.Forms.Button();
       this.stopButton = new System.Windows.Forms.Button();
@@ -60,5 +60,5 @@
       // detailsTabPage
       // 
-      this.detailsTabPage.Controls.Add(this.restartButton);
+      this.detailsTabPage.Controls.Add(this.startButton);
       this.detailsTabPage.Controls.Add(this.pauseButton);
       this.detailsTabPage.Controls.Add(this.stopButton);
@@ -66,5 +66,5 @@
       this.detailsTabPage.Controls.SetChildIndex(this.stopButton, 0);
       this.detailsTabPage.Controls.SetChildIndex(this.pauseButton, 0);
-      this.detailsTabPage.Controls.SetChildIndex(this.restartButton, 0);
+      this.detailsTabPage.Controls.SetChildIndex(this.startButton, 0);
       // 
       // tabControl
@@ -79,14 +79,14 @@
       this.modifyItemButton.Text = "Show/Modify Optimizer";
       // 
-      // restartButton
+      // startButton
       // 
-      this.restartButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.restartButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Restart;
-      this.restartButton.Location = new System.Drawing.Point(3, 348);
-      this.restartButton.Name = "restartButton";
-      this.restartButton.Size = new System.Drawing.Size(24, 24);
-      this.restartButton.TabIndex = 34;
-      this.restartButton.UseVisualStyleBackColor = true;
-      this.restartButton.Click += new System.EventHandler(this.restartButton_Click);
+      this.startButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.startButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Play;
+      this.startButton.Location = new System.Drawing.Point(3, 348);
+      this.startButton.Name = "startButton";
+      this.startButton.Size = new System.Drawing.Size(24, 24);
+      this.startButton.TabIndex = 34;
+      this.startButton.UseVisualStyleBackColor = true;
+      this.startButton.Click += new System.EventHandler(this.startButton_Click);
       // 
       // pauseButton
@@ -139,5 +139,4 @@
       // OptimizerHiveTaskView
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Name = "OptimizerHiveTaskView";
@@ -156,5 +155,5 @@
     #endregion
 
-    private System.Windows.Forms.Button restartButton;
+    private System.Windows.Forms.Button startButton;
     private System.Windows.Forms.Button pauseButton;
     private System.Windows.Forms.Button stopButton;